<?php
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;

class PeriodoDeGeracaoRNFFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function findPeriodoGeracaoRNF($params) {
        $sql = "
            SELECT E.CDEMPRESA, E.NMEMPRESA, P.DTINICIAL, P.DTFINAL
                FROM EMPRESA E 
                    LEFT JOIN PERIODORNF P
                        ON P.CDEMPRESA = E.CDEMPRESA
                            AND P.NRORG = E.NRORG
                WHERE E.NRORG = :NRORG
            ORDER BY CDEMPRESA
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function verificaParametrizacao($params) {
        $sql = "
            SELECT 1
                FROM PERIODORNF
                WHERE CDEMPRESA = :CDEMPRESA
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        
        return $std->fetchAll();
    }
    
    public function insertPeriodoGeracaoRNF($params){
        $sql = "
            INSERT INTO PERIODORNF
                (CDEMPRESA, DTINICIAL, DTFINAL)
            VALUES
                (:CDEMPRESA, :DTINICIAL, :DTFINAL)
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function updatePeriodoGeracaoRNF($params){
        $sql = "
            UPDATE PERIODORNF
                SET DTINICIAL = :DTINICIAL,
                    DTFINAL   = :DTFINAL
                WHERE CDEMPRESA = :CDEMPRESA
        ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}